// Code generated by go-swagger; DO NOT EDIT.

package character

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	strfmt "github.com/go-openapi/strfmt"

	"../../models"
)

// GetCharactersCharacterIDFatigueReader is a Reader for the GetCharactersCharacterIDFatigue structure.
type GetCharactersCharacterIDFatigueReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCharactersCharacterIDFatigueReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetCharactersCharacterIDFatigueOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 403:
		result := NewGetCharactersCharacterIDFatigueForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetCharactersCharacterIDFatigueInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetCharactersCharacterIDFatigueOK creates a GetCharactersCharacterIDFatigueOK with default headers values
func NewGetCharactersCharacterIDFatigueOK() *GetCharactersCharacterIDFatigueOK {
	return &GetCharactersCharacterIDFatigueOK{}
}

/*GetCharactersCharacterIDFatigueOK handles this case with default header values.

Jump activation and fatigue information
*/
type GetCharactersCharacterIDFatigueOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload GetCharactersCharacterIDFatigueOKBody
}

func (o *GetCharactersCharacterIDFatigueOK) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/fatigue/][%d] getCharactersCharacterIdFatigueOK  %+v", 200, o.Payload)
}

func (o *GetCharactersCharacterIDFatigueOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDFatigueForbidden creates a GetCharactersCharacterIDFatigueForbidden with default headers values
func NewGetCharactersCharacterIDFatigueForbidden() *GetCharactersCharacterIDFatigueForbidden {
	return &GetCharactersCharacterIDFatigueForbidden{}
}

/*GetCharactersCharacterIDFatigueForbidden handles this case with default header values.

Forbidden
*/
type GetCharactersCharacterIDFatigueForbidden struct {
	Payload *models.Forbidden
}

func (o *GetCharactersCharacterIDFatigueForbidden) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/fatigue/][%d] getCharactersCharacterIdFatigueForbidden  %+v", 403, o.Payload)
}

func (o *GetCharactersCharacterIDFatigueForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Forbidden)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDFatigueInternalServerError creates a GetCharactersCharacterIDFatigueInternalServerError with default headers values
func NewGetCharactersCharacterIDFatigueInternalServerError() *GetCharactersCharacterIDFatigueInternalServerError {
	return &GetCharactersCharacterIDFatigueInternalServerError{}
}

/*GetCharactersCharacterIDFatigueInternalServerError handles this case with default header values.

Internal server error
*/
type GetCharactersCharacterIDFatigueInternalServerError struct {
	Payload *models.InternalServerError
}

func (o *GetCharactersCharacterIDFatigueInternalServerError) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/fatigue/][%d] getCharactersCharacterIdFatigueInternalServerError  %+v", 500, o.Payload)
}

func (o *GetCharactersCharacterIDFatigueInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.InternalServerError)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetCharactersCharacterIDFatigueOKBody get_characters_character_id_fatigue_ok
//
// 200 ok object
swagger:model GetCharactersCharacterIDFatigueOKBody
*/
type GetCharactersCharacterIDFatigueOKBody struct {

	// get_characters_character_id_fatigue_jump_fatigue_expire_date
	//
	// Character's jump fatigue expiry
	// Required: true
	JumpFatigueExpireDate *strfmt.DateTime `json:"jump_fatigue_expire_date"`

	// get_characters_character_id_fatigue_last_jump_date
	//
	// Character's last jump activation
	// Required: true
	LastJumpDate *strfmt.DateTime `json:"last_jump_date"`

	// get_characters_character_id_fatigue_last_update_date
	//
	// Character's last jump update
	// Required: true
	LastUpdateDate *strfmt.DateTime `json:"last_update_date"`
}

// Validate validates this get characters character ID fatigue o k body
func (o *GetCharactersCharacterIDFatigueOKBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateJumpFatigueExpireDate(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateLastJumpDate(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateLastUpdateDate(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetCharactersCharacterIDFatigueOKBody) validateJumpFatigueExpireDate(formats strfmt.Registry) error {

	if err := validate.Required("getCharactersCharacterIdFatigueOK"+"."+"jump_fatigue_expire_date", "body", o.JumpFatigueExpireDate); err != nil {
		return err
	}

	return nil
}

func (o *GetCharactersCharacterIDFatigueOKBody) validateLastJumpDate(formats strfmt.Registry) error {

	if err := validate.Required("getCharactersCharacterIdFatigueOK"+"."+"last_jump_date", "body", o.LastJumpDate); err != nil {
		return err
	}

	return nil
}

func (o *GetCharactersCharacterIDFatigueOKBody) validateLastUpdateDate(formats strfmt.Registry) error {

	if err := validate.Required("getCharactersCharacterIdFatigueOK"+"."+"last_update_date", "body", o.LastUpdateDate); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetCharactersCharacterIDFatigueOKBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetCharactersCharacterIDFatigueOKBody) UnmarshalBinary(b []byte) error {
	var res GetCharactersCharacterIDFatigueOKBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
