// Code generated by go-swagger; DO NOT EDIT.

package faction_warfare

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	strfmt "github.com/go-openapi/strfmt"

	"../../models"
)

// GetFwWarsReader is a Reader for the GetFwWars structure.
type GetFwWarsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetFwWarsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetFwWarsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 500:
		result := NewGetFwWarsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetFwWarsOK creates a GetFwWarsOK with default headers values
func NewGetFwWarsOK() *GetFwWarsOK {
	return &GetFwWarsOK{}
}

/*GetFwWarsOK handles this case with default header values.

A list of NPC factions at war
*/
type GetFwWarsOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetFwWarsOKBodyItems0
}

func (o *GetFwWarsOK) Error() string {
	return fmt.Sprintf("[GET /fw/wars/][%d] getFwWarsOK  %+v", 200, o.Payload)
}

func (o *GetFwWarsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetFwWarsInternalServerError creates a GetFwWarsInternalServerError with default headers values
func NewGetFwWarsInternalServerError() *GetFwWarsInternalServerError {
	return &GetFwWarsInternalServerError{}
}

/*GetFwWarsInternalServerError handles this case with default header values.

Internal server error
*/
type GetFwWarsInternalServerError struct {
	Payload *models.InternalServerError
}

func (o *GetFwWarsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /fw/wars/][%d] getFwWarsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetFwWarsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.InternalServerError)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetFwWarsOKBodyItems0 get_fw_wars_200_ok
//
// 200 ok object
swagger:model GetFwWarsOKBodyItems0
*/
type GetFwWarsOKBodyItems0 struct {

	// get_fw_wars_against_id
	//
	// The faction ID of the enemy faction.
	// Required: true
	AgainstID *int32 `json:"against_id"`

	// get_fw_wars_faction_id
	//
	// faction_id integer
	// Required: true
	FactionID *int32 `json:"faction_id"`
}

// Validate validates this get fw wars o k body items0
func (o *GetFwWarsOKBodyItems0) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateAgainstID(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateFactionID(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetFwWarsOKBodyItems0) validateAgainstID(formats strfmt.Registry) error {

	if err := validate.Required("against_id", "body", o.AgainstID); err != nil {
		return err
	}

	return nil
}

func (o *GetFwWarsOKBodyItems0) validateFactionID(formats strfmt.Registry) error {

	if err := validate.Required("faction_id", "body", o.FactionID); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetFwWarsOKBodyItems0) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetFwWarsOKBodyItems0) UnmarshalBinary(b []byte) error {
	var res GetFwWarsOKBodyItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
